/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using com.db4o.query;

namespace com.db4o.test
{
    /// <summary>
    /// Summary description for IndexedByIdentity.
    /// </summary>
    public class IndexedByIdentity
    {
        Atom atom;
    
        static int COUNT = 10;
    
        public void configure()
        {
            Db4o.configure().objectClass(this).objectField("atom").indexed(true);
        }
    
        public void store()
        {
            for (int i = 0; i < COUNT; i++) 
            {
                IndexedByIdentity ibi = new IndexedByIdentity();
                ibi.atom = new Atom("ibi" + i);
                Tester.store(ibi);
            } 
        }
    
        public void test()
        {
        
            for (int i = 0; i < COUNT; i++) 
            {
                Query q = Tester.query();
                q.constrain(typeof(Atom));
                q.descend("name").constrain("ibi" + i);
                ObjectSet objectSet = q.execute();
                Atom child = (Atom)objectSet.next();
                // child.name = "r�nzelbr�nft";
                q = Tester.query();
                q.constrain(typeof(IndexedByIdentity));
                q.descend("atom").constrain(child).identity();
                objectSet = q.execute();
                Tester.ensure(objectSet.size() == 1);
                IndexedByIdentity ibi = (IndexedByIdentity)objectSet.next();
                Tester.ensure(ibi.atom == child);
            }
        }
    
    
    }
}
